/*
 *  Nets.C
 *  
 *
 *  Created by Sergio on 12/07/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#include "Nets.H"
#include <iostream>

using namespace std;

DSL_network networkAttack;
DSL_network networkDefense;
DSL_network networkBuildingBarracks;
DSL_network networkBuildingFactory;
DSL_network networkTrainingWorker;
DSL_network networkTrainingUnit;
DSL_network networkNewBase;

void Nets::init(){

	networkAttack.ReadFile("./apps/BlackRose/src/nets/NetworkAttack.xdsl");	
	networkDefense.ReadFile("./apps/BlackRose/src/nets/NetworkDefense.xdsl");
	networkBuildingBarracks.ReadFile("./apps/BlackRose/src/nets/NetworkBuildingBarracks.xdsl");
	networkBuildingFactory.ReadFile("./apps/BlackRose/src/nets/NetworkBuildingFactory.xdsl");
	networkTrainingWorker.ReadFile("./apps/BlackRose/src/nets/NetworkTrainingWorker.xdsl");
	networkTrainingUnit.ReadFile("./apps/BlackRose/src/nets/NetworkTrainingUnit.xdsl");
	networkNewBase.ReadFile("./apps/BlackRose/src/nets/NetworkNewBase.xdsl");

}

float Nets::getValueAttack(float force, float localized, float finished, float attacking){
	
	DSL_doubleArray theProbs;
	//DSL_doubleArray * definition;
	DSL_idArray * names;
	DSL_Dmatrix * value;
	
	/* Asignamos los nuevos valores de entrada */
	
	/* Nodo Force */
	int nforce = networkAttack.FindNode("force");	
	theProbs.SetSize(2);
	theProbs[0] = force;
	theProbs[1] = (1 - force);	
	networkAttack.GetNode(nforce)->Definition()->SetDefinition(theProbs);	
	
	/* Nodo Located enemy? */	
	int nlocated = networkAttack.FindNode("located");	
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = localized;
	theProbs[1] = (1 - localized);
	networkAttack.GetNode(nlocated)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Time */
	int ntime = networkAttack.FindNode("time");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = finished;
	theProbs[1] = (1 - finished);
	networkAttack.GetNode(ntime)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Attacking? */
	int nattacking = networkAttack.FindNode("attacking");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = attacking;
	theProbs[1] = (1 - attacking);
	networkAttack.GetNode(nattacking)->Definition()->SetDefinition(theProbs);
	
	
	/* Actualizamos la red */
	networkAttack.UpdateBeliefs();
	
	
	/* Nodo Attack */	
	int nattack = networkAttack.FindNode("attack");
	
	networkAttack.GetNode(nattack)->Value()->GetValue(&value);
	names = networkAttack.GetNode(nattack)->Definition()->GetOutcomesNames();
	
	return (*value)[0];
}

float Nets::getValueDefense(float enemyAttack, float building, float longTime, float finished, float playerAttack){
	
	DSL_doubleArray theProbs;
	DSL_idArray * names;
	DSL_Dmatrix * value;
	
	/* Asignamos los nuevos valores de entrada */
	
	/* Nodo Enemy attacking? */
	int nenemy = networkDefense.FindNode("enemy");	
	theProbs.SetSize(2);
	theProbs[0] = enemyAttack;
	theProbs[1] = (1 - enemyAttack);	
	networkDefense.GetNode(nenemy)->Definition()->SetDefinition(theProbs);	
	
	/* Nodo Is there building? */	
	int nbuilding = networkDefense.FindNode("building");	
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = building;
	theProbs[1] = (1 - building);
	networkDefense.GetNode(nbuilding)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Time last attack */
	int nlast = networkDefense.FindNode("last");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = longTime;
	theProbs[1] = (1 - longTime);
	networkDefense.GetNode(nlast)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Time */
	int ntime = networkDefense.FindNode("time");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = finished;
	theProbs[1] = (1 - finished);
	networkDefense.GetNode(ntime)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Are we attacking? */
	int nattacking = networkDefense.FindNode("attacking");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = playerAttack;
	theProbs[1] = (1 - playerAttack);
	networkDefense.GetNode(nattacking)->Definition()->SetDefinition(theProbs);
	
	/* Actualizamos la red */
	networkDefense.UpdateBeliefs();	
	
	/* Nodo Defense */	
	int ndefense = networkDefense.FindNode("defense");
	
	networkDefense.GetNode(ndefense)->Value()->GetValue(&value);
	names = networkDefense.GetNode(ndefense)->Definition()->GetOutcomesNames();
	
	return (*value)[0];
}

float Nets::getValueBuildingBarracks(float few, float yesBarracks, float yesBuildingNow, float finished,
												   float yesMoreBases, float small, float yesControlCenter, float yesWorker){
	
	DSL_doubleArray theProbs;
	//DSL_doubleArray * definition;
	DSL_idArray * names;
	DSL_Dmatrix * value;
	
	/* Asignamos los nuevos valores de entrada */
	
	/* Nodo Minerals */
	int nminerals = networkBuildingBarracks.FindNode("minerals_building");	
	theProbs.SetSize(2);
	theProbs[0] = few;
	theProbs[1] = (1 - few);	
	networkBuildingBarracks.GetNode(nminerals)->Definition()->SetDefinition(theProbs);	
	
	/* Nodo Is there Barracks? */	
	int nbarracks = networkBuildingBarracks.FindNode("barracks");	
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = yesBarracks;
	theProbs[1] = (1 - yesBarracks);
	networkBuildingBarracks.GetNode(nbarracks)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Building now? */
	int nbuilding = networkBuildingBarracks.FindNode("building_now");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = yesBuildingNow;
	theProbs[1] = (1 - yesBuildingNow);
	networkBuildingBarracks.GetNode(nbuilding)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Time */
	int ntime = networkBuildingBarracks.FindNode("time");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = finished;
	theProbs[1] = (1 - finished);
	networkBuildingBarracks.GetNode(ntime)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Hace more bases? */
	int nbases = networkBuildingBarracks.FindNode("bases");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = yesMoreBases;
	theProbs[1] = (1 - yesMoreBases);
	networkBuildingBarracks.GetNode(nbases)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Distance base to enemy base */
	int ndistance = networkBuildingBarracks.FindNode("distance_base_enemyBase");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = small;
	theProbs[1] = (1 - small);
	networkBuildingBarracks.GetNode(ndistance)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Is there control center? */
	int ncontrolCenter = networkBuildingBarracks.FindNode("controlCenter");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = yesControlCenter;
	theProbs[1] = (1 - yesControlCenter);
	networkBuildingBarracks.GetNode(ncontrolCenter)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Worker */
	int nworker = networkBuildingBarracks.FindNode("worker");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = yesWorker;
	theProbs[1] = (1 - yesWorker);
	networkBuildingBarracks.GetNode(nworker)->Definition()->SetDefinition(theProbs);
	
	/* Actualizamos la red */
	networkBuildingBarracks.UpdateBeliefs();
		
	
	/* Nodo Building barracks */	
	int nbuildingBarracks = networkBuildingBarracks.FindNode("building_barracks");
	
	networkBuildingBarracks.GetNode(nbuildingBarracks)->Value()->GetValue(&value);
	names = networkBuildingBarracks.GetNode(nbuildingBarracks)->Definition()->GetOutcomesNames();
		
	return (*value)[0];
}

float Nets::getValueBuildingFactory(float few, float yesFactory, float yesBuildingNow, float finished,
												  float yesBarracks, float yesControlCenter, float yesWorker){
	
	DSL_doubleArray theProbs;
	DSL_idArray * names;
	DSL_Dmatrix * value;
	
	/* Asignamos los nuevos valores de entrada */
	
	/* Nodo Minerals */
	int nminerals = networkBuildingFactory.FindNode("minerals_building");	
	theProbs.SetSize(2);
	theProbs[0] = few;
	theProbs[1] = (1 - few);	
	networkBuildingFactory.GetNode(nminerals)->Definition()->SetDefinition(theProbs);	
	
	/* Nodo Is there factory? */	
	int nfactory = networkBuildingFactory.FindNode("factory");	
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = yesFactory;
	theProbs[1] = (1 - yesFactory);
	networkBuildingFactory.GetNode(nfactory)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Building now? */
	int nbuilding = networkBuildingFactory.FindNode("building_now");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = yesBuildingNow;
	theProbs[1] = (1 - yesBuildingNow);
	networkBuildingFactory.GetNode(nbuilding)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Time */
	int ntime = networkBuildingFactory.FindNode("time");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = finished;
	theProbs[1] = (1 - finished);
	networkBuildingFactory.GetNode(ntime)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Is there barracks? */
	int nbarracks = networkBuildingFactory.FindNode("barracks");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = yesBarracks;
	theProbs[1] = (1 - yesBarracks);
	networkBuildingFactory.GetNode(nbarracks)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Is there control center? */
	int ncontrolCenter = networkBuildingFactory.FindNode("controlCenter");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = yesControlCenter;
	theProbs[1] = (1 - yesControlCenter);
	networkBuildingFactory.GetNode(ncontrolCenter)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Worker */
	int nworker = networkBuildingFactory.FindNode("worker");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = yesWorker;
	theProbs[1] = (1 - yesWorker);
	networkBuildingFactory.GetNode(nworker)->Definition()->SetDefinition(theProbs);
	
	/* Actualizamos la red */
	networkBuildingFactory.UpdateBeliefs();
		
	/* Nodo Building factory */	
	int nbuildingFactory = networkBuildingFactory.FindNode("building_factory");
	
	networkBuildingFactory.GetNode(nbuildingFactory)->Value()->GetValue(&value);
	names = networkBuildingFactory.GetNode(nbuildingFactory)->Definition()->GetOutcomesNames();
	
	return (*value)[0];
}

float Nets::getValueTrainingWorker(float few, float finished, float yesControlCenter, float yesCanGather, float full){
	
	DSL_doubleArray theProbs;	
	DSL_idArray * names;
	DSL_Dmatrix * value;
	
	/* Asignamos los nuevos valores de entrada */
	
	/* Nodo Minerals */
	int nminerals = networkTrainingWorker.FindNode("minerals_training");	
	theProbs.SetSize(2);
	theProbs[0] = few;
	theProbs[1] = (1 - few);	
	networkTrainingWorker.GetNode(nminerals)->Definition()->SetDefinition(theProbs);	
	
	/* Nodo Time */
	int ntime = networkTrainingWorker.FindNode("time");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = finished;
	theProbs[1] = (1 - finished);
	networkTrainingWorker.GetNode(ntime)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Is there control center? */
	int ncontrolCenter = networkTrainingWorker.FindNode("controlCenter");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = yesControlCenter;
	theProbs[1] = (1 - yesControlCenter);
	networkTrainingWorker.GetNode(ncontrolCenter)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Can gather? */
	int ngather = networkTrainingWorker.FindNode("gather");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = yesCanGather;
	theProbs[1] = (1 - yesCanGather);
	networkTrainingWorker.GetNode(ngather)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Queue */
	int nqueue = networkTrainingWorker.FindNode("queue");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = full;
	theProbs[1] = (1 - full);
	networkTrainingWorker.GetNode(nqueue)->Definition()->SetDefinition(theProbs);
	
	/* Actualizamos la red */
	networkTrainingWorker.UpdateBeliefs();
		
	/* Nodo Training worker */	
	int ntrainingWorker = networkTrainingWorker.FindNode("training_worker");
	
	networkTrainingWorker.GetNode(ntrainingWorker)->Value()->GetValue(&value);
	names = networkTrainingWorker.GetNode(ntrainingWorker)->Definition()->GetOutcomesNames();
	
	
	return (*value)[0];
}

float Nets::getValueTrainingUnit(float min, float ko, float few, float finished, float yesBuilding, float noFull){
	
	DSL_doubleArray theProbs;	
	DSL_idArray * names;
	DSL_Dmatrix * value;
	
	/* Asignamos los nuevos valores de entrada */
	
	/* Nodo Number of units */
	int nunits = networkTrainingUnit.FindNode("units");	
	theProbs.SetSize(2);
	theProbs[0] = min;
	theProbs[1] = (1 - min);	
	networkTrainingUnit.GetNode(nunits)->Definition()->SetDefinition(theProbs);	
	
	/* Nodo Rate */	
	int nrate = networkTrainingUnit.FindNode("rate");	
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = ko;
	theProbs[1] = (1 - ko);
	networkTrainingUnit.GetNode(nrate)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Minerals */
	int nminerals = networkTrainingUnit.FindNode("minerals_training");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = few;
	theProbs[1] = (1 - few);
	networkTrainingUnit.GetNode(nminerals)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Time */
	int ntime = networkTrainingUnit.FindNode("time");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = finished;
	theProbs[1] = (1 - finished);
	networkTrainingUnit.GetNode(ntime)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Is there building? */
	int nbuilding = networkTrainingUnit.FindNode("building");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = yesBuilding;
	theProbs[1] = (1 - yesBuilding);
	networkTrainingUnit.GetNode(nbuilding)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Queue */
	int nqueue = networkTrainingUnit.FindNode("queue");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = noFull;
	theProbs[1] = (1 - noFull);
	networkTrainingUnit.GetNode(nqueue)->Definition()->SetDefinition(theProbs);
	
	
	/* Actualizamos la red */
	networkTrainingUnit.UpdateBeliefs();
		
	
	/* Nodo Training unit */	
	int ntrainingUnit = networkTrainingUnit.FindNode("training_unit");
	
	networkTrainingUnit.GetNode(ntrainingUnit)->Value()->GetValue(&value);
	names = networkTrainingUnit.GetNode(ntrainingUnit)->Definition()->GetOutcomesNames();
	
	
	return (*value)[0];
}

float Nets::getValueNewBase(float few, float force, float small, float yesMoreBases, float yesInProgress,
										  float finished, float yesPossible, float yesWorker){
	
	DSL_doubleArray theProbs;	
	DSL_idArray * names;
	DSL_Dmatrix * value;
	
	/* Asignamos los nuevos valores de entrada */
	
	/* Nodo Minerals */
	int nminerals = networkNewBase.FindNode("minerals_building");	
	theProbs.SetSize(2);
	theProbs[0] = few;
	theProbs[1] = (1 - few);	
	networkNewBase.GetNode(nminerals)->Definition()->SetDefinition(theProbs);	
	
	/* Nodo Force */	
	int nforce = networkNewBase.FindNode("force");	
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = force;
	theProbs[1] = (1 - force);
	networkNewBase.GetNode(nforce)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Distance old base to cluster minerals */
	int ndistance = networkNewBase.FindNode("distance_oldBase_clusterMineral");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = small;
	theProbs[1] = (1 - small);
	networkNewBase.GetNode(ndistance)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Have more bases? */
	int nbases = networkNewBase.FindNode("bases");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = yesMoreBases;
	theProbs[1] = (1 - yesMoreBases);
	networkNewBase.GetNode(nbases)->Definition()->SetDefinition(theProbs);
	
	/* Nodo In progress? */
	int nprogress = networkNewBase.FindNode("progress");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = yesInProgress;
	theProbs[1] = (1 - yesInProgress);
	networkNewBase.GetNode(nprogress)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Time */
	int ntime = networkNewBase.FindNode("time");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = finished;
	theProbs[1] = (1 - finished);
	networkNewBase.GetNode(ntime)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Is possible? */
	int npossible = networkNewBase.FindNode("possible");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = yesPossible;
	theProbs[1] = (1 - yesPossible);
	networkNewBase.GetNode(npossible)->Definition()->SetDefinition(theProbs);
	
	/* Nodo Worker */
	int nworker = networkNewBase.FindNode("worker");
	theProbs.Flush();
	theProbs.SetSize(2);
	theProbs[0] = yesWorker;
	theProbs[1] = (1 - yesWorker);
	networkNewBase.GetNode(nworker)->Definition()->SetDefinition(theProbs);
	
	/* Actualizamos la red */
	networkNewBase.UpdateBeliefs();
	
	
	/* Nodo New base */	
	int nnewBase = networkNewBase.FindNode("new_base");
	
	networkNewBase.GetNode(nnewBase)->Value()->GetValue(&value);
	names = networkNewBase.GetNode(nnewBase)->Definition()->GetOutcomesNames();
		
	return (*value)[0];
}


float Nets::getForce(size_t nMarines, size_t nTanks){
	
	float force = nMarines + (nTanks * 3);
	
	force = force / 60;
	
	if(force > 1)
		force = 1.0;
			
	return force;
}

float Nets::getTime(int32_t frame){
	assert(frame >= 0);
	
	int32_t seconds = (frame + 1) / 8; //8 frames per second	
	float finished = (float)seconds / 1200;
	
	return finished;
}

float Nets::getLastAttack(int32_t frameLastAttack, int32_t frame){
	assert(frame >= 0);
	assert(frameLastAttack >= 0);

	float longTime = (float)(frame - frameLastAttack)  / 8; //convert to seconds
	longTime = longTime / 90;
	
	if(longTime > 1.0)
		longTime = 1.0;
	
	return longTime;
}

float Nets::getMineralsBuildingFew(uint32_t minerals){

	float many = (float) minerals / 2800;
	
	if(many > 1.0)
		many = 1.0;
		
	float few = 1 - many;

	return few;
}

float Nets::getSmallDistanceToEnemyBase(TerrainBase::Loc centreLoc, Vector<ScalarPoint> locationsEnemyBuilding){

	float small;
	float big;
	float min = -1;	
	ScalarPoint point;
	
	FORALL(locationsEnemyBuilding, location){
				
		float distance = sqrt(square(centreLoc.x - location->x) + square(centreLoc.y - location->y));
		
		if((min == -1) || (distance < min)){
			min = distance;
			point = *location;
		}
	
	}
	
	if(min == -1){
		min = 1448;
	
	}
		
	big = (float) min / 1448;
	small = 1 - big;
	
	return small;
}

float Nets::getMineralsTrainingFew(uint32_t minerals){
		
	float many = (float) minerals / 600;
	
	if(many > 1.0)
		many = 1.0;
	
	float few = 1 - many;
		
	return few;	
}

float Nets::getMinNumberOfUnit(const std::string & bp_name, size_t count){

	float min = 0;
	float max = 0;
	
	if(bp_name == "marine"){
		max = (float) count / 40;
		
	}else if(bp_name == "tank"){
		max = (float) count / 13;		
	}
	
	if(max > 1.0)
		max = 1.0;
	
	min = 1.0 - max;
		
	return min;
}

float Nets::getKoRatio(const std::string & bp_name, size_t countMarines, size_t countTanks){
	
	float ko = 0;
	float ok = 0;
		
	if(bp_name == "marine"){
				
		if((countMarines == 0) && (countTanks == 0))
			ok = 0.0;
		else if((countMarines != 0) && (countTanks == 0))
			ok = 3.0;
		else if(countTanks != 0)
			ok = (float) countMarines / countTanks;
		
		if(ok > 3)
			ok = 3.0;
			
		ok = ok / 3;
		
		ko = 1.0 - ok;
		
	}else if(bp_name == "tank"){
				
		if(countTanks == 0)
			ok = 6.0;
		else
			ok = (float) countMarines / countTanks;
			
		if(ok < 3.0)
			ok = 3.0;
			
		if(ok > 6.0)
			ok = 6.0;
			
		ok = ok / 3;
		
		ko = ok - 1;
		
		ok = 1 - ko;
		
	}	
	
	return ko;	
}
