/*
 *  NewBase.C
 *  
 *
 *  Created by Sergio on 16/07/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#include "NewBase.H"


NewBase::NewBase(ModuleSet & ms, Vector<GameObj*> units, GameObj* gob, TerrainBase::Loc centroidCluster, TerrainBase::Loc locBuildingEnemy, Finance::Ticket * reserve):
SpecialCommander(ms, 25), locCluster(centroidCluster), locEnemy(locBuildingEnemy), mc(ms.get_movement(), "Default", "Default"){
	
	if (gob && gob->sod.in_game && *gob->sod.x >= 0 && !gob->is_dead()) {
		worker = gob;
		moduleSet.get_watcher().notifyOnDeath(this, gob);
	}else{
		worker = NULL;
	}
	
	defense = NULL;
	finish = false;
	running = false;
	pos = "";
	contador = 0;
	move = false;
	workerMoved = false;
	action = 0;
	contador2 = 0;
	cambiarUnidad = false;
	funds = reserve;
	
	init(units);	
}

/* Inicializa la defensa, con el objetivo de garantizar el control del terreno
 antes de comenzar la construccion de la nueva base */
void NewBase::init(Vector<GameObj*> units){
	
	assert(locCluster.x >= 0);
	assert(locCluster.x <= 1023);
	assert(locCluster.y >= 0);
	assert(locCluster.y <= 1023);
	
	
	assert(locEnemy.x >= 0);
	assert(locEnemy.x <= 1023);
	assert(locEnemy.y >= 0);
	assert(locEnemy.y <= 1023);
	
	TerrainBase::Loc tileCluster = getTile(locCluster);
	TerrainBase::Loc tileEnemy = getTile(locEnemy);
	TerrainBase::Loc centre;
		
	/* Determinamos el centro del radio de defensa en 
	 funcion del edificio enemigo mas cercano. El objetivo
	 es construir el edificio enemigo de forma que el cluster
	 de minerales se encuentre entre ambos edificios */		
	 
	/* El cluster y el edificio enemigo estan alineados verticalmente */
	if((tileEnemy.x == tileCluster.x) && (tileEnemy.y != tileCluster.y)){
			
		/* El cluster esta colocado mas arriba que el edificio enemigo */
		/* La nueva base se coloca mas arriba que el cluster */
		if((tileEnemy.y > tileCluster.y) && ((locCluster.y - 100) >= 0)){
			centre.y = (locCluster.y - 100);
			centre.x = locCluster.x;
			pos = "N";			
		
		/* El cluster esta colocado mas abajo que el edificio enemigo */
		/* La nueva base se coloca mas abajo que el cluster */
		}else if((tileEnemy.y < tileCluster.y) && ((locCluster.y + 100) <= 1023)){
			centre.y = (locCluster.y + 100);
			centre.x = locCluster.x;
			pos = "S";			
			
		/* La nueva base se coloca a la izquierda del cluster */
		}else if((locCluster.x - 100) >= 0){
			centre.y = locCluster.y;
			centre.x = (locCluster.x - 100);
			pos = "W";
						
		/* La nueva base se coloca a la derecha del cluster */
		}else if((locCluster.x + 100) <= 1023){
			centre.y = locCluster.y;
			centre.x = (locCluster.x + 100);
			pos = "E";						
		}		
		
	/* El cluster y el edificio enemigo estan alineados horizontalmente */
	}else if((tileEnemy.x != tileCluster.x) && (tileEnemy.y == tileCluster.y)){
	
		/* El cluster esta colocado a la izquierda del edificio enemigo */
		/* La nueva base se coloca a la izquierda del cluster */
		if((tileEnemy.x > tileCluster.x) && ((locCluster.x - 100) >= 0)){
			centre.x = (locCluster.x - 100);
			centre.y = locCluster.y;
			pos = "W";			
			
		/* El cluster esta colocado a la derecha del edificio enemigo */
		/* La nueva base se coloca a la derecha del cluster */
		}else if((tileEnemy.x < tileCluster.x) && ((locCluster.x + 100) <= 1023)){
			centre.x = (locCluster.x + 100);
			centre.y = locCluster.y;
			pos = "E";			
			
		/* La nueva base se coloca a arriba cluster */
		}else if((locCluster.y - 100) >= 0){
			centre.x = locCluster.x;
			centre.y = (locCluster.y - 100);
			pos = "N";			
			
		/* La nueva base se coloca a la abajo del cluster */
		}else if((locCluster.y + 100) <= 1023){
			centre.x = locCluster.x;
			centre.y = (locCluster.y + 100);
			pos = "S";
						
		}	
		
	/* Arriba a la izquierda, el cluster respecto al edificio enemigo */
	}else if((tileEnemy.x != tileCluster.x) && (tileEnemy.y != tileCluster.y) && (tileEnemy.x > tileCluster.x) && (tileEnemy.y > tileCluster.y)){
		
		/* La nueva base se coloca mas cerca de la esquina superior izquierda */
		if(((locCluster.x - 100) >= 0) && ((locCluster.y - 100) >= 0)){
			centre.x = (locCluster.x - 100);
			centre.y = (locCluster.y - 100);
			pos = "NW";
						
		/* La nueva base se coloca arriba del cluster */
		}else if((locCluster.y - 100) >= 0){
			centre.x = locCluster.x;
			centre.y = (locCluster.y - 100);
			pos = "N";
					
		/* La nueva base se coloca a la izquierda del cluster */
		}else if((locCluster.x - 100) >= 0){
			centre.x = (locCluster.x - 100);
			centre.y = locCluster.y;
			pos = "W";
					
		/* La nueva base se coloca a la derecha del cluster */
		}else if((locCluster.x + 100) <= 1023){
			centre.x = (locCluster.x + 100);
			centre.y = locCluster.y;
			pos = "E";
					
		}		
		
	/* Abajo a la izquierda, el cluster respecto al edificio enemigo */
	}else if((tileEnemy.x != tileCluster.x) && (tileEnemy.y != tileCluster.y) && (tileEnemy.x > tileCluster.x) && (tileEnemy.y < tileCluster.y)){
		
		/* La nueva base se coloca mas cerca de la esquina inferior izquierda */
		if(((locCluster.x - 100) >= 0) && ((locCluster.y + 100) <= 1023)){
			centre.x = (locCluster.x - 100);
			centre.y = (locCluster.y + 100);
			pos = "SW";
						
		/* La nueva base se coloca abajo del cluster */
		}else if((locCluster.y + 100) <= 1023){
			centre.x = locCluster.x;
			centre.y = (locCluster.y + 100);
			pos = "S";
						
		/* La nueva base se coloca a la izquierda del cluster */
		}else if((locCluster.x - 100) >= 0){
			centre.x = (locCluster.x - 100);
			centre.y = locCluster.y;
			pos = "W";
						
		/* La nueva base se coloca a la derecha del cluster */
		}else if((locCluster.x + 100) <= 1023){
			centre.x = (locCluster.x + 100);
			centre.y = locCluster.y;
			pos = "E";
						
		}
		
	/* Arriba a la derecha, el cluster respecto al edificio enemigo */
	}else if((tileEnemy.x != tileCluster.x) && (tileEnemy.y != tileCluster.y) && (tileEnemy.x < tileCluster.x) && (tileEnemy.y > tileCluster.y)){
		
		/* La nueva base se coloca mas cerca de la esquina superior derecha */
		if(((locCluster.x + 100) <= 1023) && ((locCluster.y - 100) >= 0)){
			centre.x = (locCluster.x + 100);
			centre.y = (locCluster.y - 100);
			pos = "NE";
						
		/* La nueva base se coloca arriba del cluster */
		}else if((locCluster.y - 100) >= 0){
			centre.x = locCluster.x;
			centre.y = (locCluster.y - 100);
			pos = "N";
						
		/* La nueva base se coloca a la derecha del cluster */
		}else if((locCluster.x + 100) <= 1023){
			centre.x = (locCluster.x + 100);
			centre.y = locCluster.y;
			pos = "E";
						
		/* La nueva base se coloca a la izquierda del cluster */
		}else if((locCluster.x - 100) >= 0){
			centre.x = (locCluster.x - 100);
			centre.y = locCluster.y;
			pos = "W";
						
		}
		
	/* Abajo a la derecha, el cluster respecto al edificio enemigo */
	}else if((tileEnemy.x != tileCluster.x) && (tileEnemy.y != tileCluster.y) && (tileEnemy.x < tileCluster.x) && (tileEnemy.y < tileCluster.y)){
		
		/* La nueva base se coloca mas cerca de la esquina inferior derecha */
		if(((locCluster.x + 100) <= 1023) && ((locCluster.y + 100) <= 1023)){
			centre.x = (locCluster.x + 100);
			centre.y = (locCluster.y + 100);
			pos = "SE";
						
		/* La nueva base se coloca abajo del cluster */
		}else if((locCluster.y + 100) <= 1023){
			centre.x = locCluster.x;
			centre.y = (locCluster.y + 100);
			pos = "S";
						
		/* La nueva base se coloca a la derecha del cluster */
		}else if((locCluster.x + 100) <= 1023){
			centre.x = (locCluster.x + 100);
			centre.y = locCluster.y;
			pos = "E";
						
		/* La nueva base se coloca a la izquierda del cluster */
		}else if((locCluster.x - 100) >= 0){
			centre.x = (locCluster.x - 100);
			centre.y = locCluster.y;
			pos = "W";
						
		}
	}
		
	defense = new SpecialDefenseCommander(this, centre, 150, 0, false);
		
	FORALL(units, unit)
		defense->addUnit(*unit);
	
	units.clear();	
}


/* Mueve a todas las unidades militares para que el worker pueda realizar la construccion */
void NewBase::moveDefense(){

	move = true;
	TerrainBase::Loc centre;

	/* Obtenemos todas las unidades militares */
	Vector<GameObj*> units = defense->getAllUnits();
	
	/* Eliminamos la defensa */
	//delete defense;
	defense = NULL;
	
	/* Obtenemos la nueva posicion para las unidades militares */
	/* Derecha */
	if((target.x + 90) <= 1023){
		centre.x = (target.x + 90);
		centre.y = target.y;
	
	/* Izquierda */
	}else if((target.x - 90) >= 0){
		centre.x = (target.x - 90);
		centre.y = target.y;
		
	/* Abajo */
	}else if((target.y + 90) <= 1023){
		centre.x = target.x;
		centre.y = (target.y + 90);
		
	/* Arriba */
	}else if((target.y - 90) >= 0){
		centre.x = target.x;
		centre.y = (target.y - 90);
		
	}
	
	/* Creamos una nueva defensa un poco alejada de la nueva base */
	defense = new SpecialDefenseCommander(this, centre, 75, 0, false);
	
	FORALL(units, unit)
	defense->addUnit(*unit);
	
	units.clear();
	
	move = false;
}


/* Mueve la unidad worker hasta el punto
 donde tiene que construir el control center */
void NewBase::moveWorker(){
						
	/* is worker not started */
	if(!running){	
		
		assert(pos != "");
		
		/* Obtenemos las coordenadas del objetivo y las asignamos */
		if(pos == "N"){
			target.x = locCluster.x;
			target.y = (locCluster.y - 70);
		
		}else if(pos == "NE"){
			target.x = (locCluster.x + 70);
			target.y = (locCluster.y - 70);
			
		}else if(pos == "E"){
			target.x = (locCluster.x + 70);
			target.y = locCluster.y;
			
		}else if(pos == "SE"){
			target.x = (locCluster.x + 70);
			target.y = (locCluster.y + 70);
			
		}else if(pos == "S"){
			target.x = locCluster.x;
			target.y = (locCluster.y + 70);
			
		}else if(pos == "SW"){
			target.x = (locCluster.x - 70);
			target.y = (locCluster.y + 70);
			
		}else if(pos == "W"){
			target.x = (locCluster.x - 70);
			target.y = locCluster.y;			
			
		}else if(pos == "NW"){
			target.x = (locCluster.x - 70);
			target.y = (locCluster.y - 70);
			
		}
			
		assert(target.x <= 1023);
		assert(target.x >= 0);
		assert(target.y <= 1023);
		assert(target.y >= 0);
		mc.moveUnit(worker, Movement::TouchPoint(target));
		running = true;
		contador = 0;
						
	/* En destino */				
	}else if(getDistanceToTarget(target, *worker->sod.x, *worker->sod.y) < 12){
		workerMoved = true;					
				
	/* Esta parado */
	}else if((*worker->sod.speed == 0) && (contador < 50)){
		contador++;
				
	/* Esta en movimiento */
	}else if(*worker->sod.speed != 0){
		contador = 0;
				
	/* Estoy pillado */
	}else if((contador >= 50) && (contador2 < 10)){
		contador2++;
		running = false;
			
	/* La unidad esta pillada y no puede llegar al destino */
	}else if(contador2 >= 10){
		cambiarUnidad = true;
	}
}


bool NewBase::isFinish(){
	return finish;
}


bool NewBase::run(){

	bool success = true;
			
	if(defense != NULL)
		defense->update();
	
	/* Controlar el terreno */	
	if(action == 0){
	
		if((defense != NULL) && (defense->isUnderControl())){
			action  = 1;			
		}			
	
	/* Mover worker */
	}else if(action == 1){
		
		if(worker != NULL)
			moveWorker();
				
		if(workerMoved){
			action = 2;
			moveDefense();			
		}
	
	/* Mover defense */
	}else if(action == 2){
	
		if((worker != NULL) && (defense != NULL) && (defense->isUnderControl())){
			finish = true;			
		}
	
	}
	
	if((worker == NULL) || (cambiarUnidad) || ((defense != NULL) && (defense->countUnits("") == 0) && (move == false))){
	   success = false;
	   finish = false;
	}
	
	return success;
}


TerrainBase::Loc NewBase::getTile(TerrainBase::Loc point){
	
	TerrainBase::Loc tile;
	
	tile.x = point.x / 16;	
	tile.y = point.y / 16;	
	
	assert(point.x < 1024);
	assert(point.y >= 0);
	
	assert(point.y < 1024);
	assert(point.x >= 0);
	
	assert(tile.x < 64);
	assert(tile.x >= 0);
	
	assert(tile.x < 64);
	assert(tile.y >= 0);
		
	return tile;
}


real8 NewBase::getDistanceToTarget(TerrainBase::Loc target, sint4 x, sint4 y){
	real8 distancia = square(real8(target.x - x)) + square(real8(target.y - y));
	distancia = sqrt(distancia);	
	return distancia;	
}


void NewBase::onLoseUnit(GameObj * unit){
	
    if(unit == worker)
		worker = NULL;	
	
	finish = false;
	assert(worker == NULL);
}


GameObj* NewBase::removeWorker(){
	if(worker != NULL)
		moduleSet.get_watcher().cancelNotifyOnDeath(this, worker);	
	
	GameObj* gob = worker;
	worker = NULL;
	
	return gob;
}


Vector<GameObj*> NewBase::removeDefense(){
		
	/* Obtenemos todas las unidades militares */
	Vector<GameObj*> units = defense->getAllUnits();
	
	/* Eliminamos la defensa */
	delete defense;
	defense = NULL;
	
	return units;
}

TerrainBase::Loc NewBase::getLoc(){
	return target;
}

/* Solo se puede volver a intentar si muere la unidad worker */
bool NewBase::retry(){

	bool success = true;
	
	if((defense != NULL) && (defense->countUnits("") == 0) && (move == false))
		success = false;
		
	return success;
}


void NewBase::addNewWorker(GameObj* gob){
	
	if (gob && gob->sod.in_game && *gob->sod.x >= 0 && !gob->is_dead()) {
		moduleSet.get_watcher().notifyOnDeath(this, gob);
		worker = gob;
		running = false;
		contador = 0;
		workerMoved = false;
		contador2 = 0;
		cambiarUnidad = false;		
		if(action >= 1)
			action = 1;	
	}
}

bool NewBase::getCambiarUnidad(){
	return cambiarUnidad;
}

void NewBase::onReceiveUnit( GameObj * unit, Watcher::WatchID ){}

bool NewBase::onEvent(const Event &event){return false;}


void NewBase::exec(){}


Finance::Ticket * NewBase::getFunds(){
	return funds;
}