/*
 *  NewBase.h
 *  
 *
 *  Created by Sergio on 16/07/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */


#ifndef NewBase_H
#define NewBase_H

#include "SpecialDefenseCommander.H"
#include "Finance.H"
#include <iostream>

/* Clase NewBase */
class NewBase : public SpecialCommander{

public:

	/* Constructor */
	NewBase(ModuleSet & ms, Vector<GameObj*> units, GameObj* gob, TerrainBase::Loc centroidCluster, TerrainBase::Loc locBuildingEnemy, Finance::Ticket * reserve);
	
	bool run();
	
	TerrainBase::Loc getLoc();
	
	bool isFinish();
	
	GameObj* removeWorker();
	
	Vector<GameObj*> removeDefense();
	
	bool retry();
	
	void addNewWorker(GameObj* gob);
	
	bool getCambiarUnidad();
	
	Finance::Ticket * getFunds();
			
private:

	SpecialDefenseCommander * defense;
		
	GameObj* worker;
	
	const TerrainBase::Loc locCluster;
	
	const TerrainBase::Loc locEnemy;
	
	bool finish;
	
	bool running;
	
	Movement::Context mc;
	
	std::string pos;
	
	TerrainBase::Loc target;
	
	int contador;
	
	bool move;
	
	bool workerMoved;
	
	int action;
	
	int contador2;
	
	bool cambiarUnidad;
	
	Finance::Ticket * funds;

	void init(Vector<GameObj*> units);
		
	void moveDefense();
	
	void moveWorker();		
	
	TerrainBase::Loc getTile(TerrainBase::Loc point);
	
	real8 getDistanceToTarget(TerrainBase::Loc target, sint4 x, sint4 y);	
	
	void onLoseUnit( GameObj * unit );
	
	void exec();
	
	void onReceiveUnit( GameObj * unit, Watcher::WatchID );
	
    bool onEvent(const Event &event);
};

#endif
