#include "SpecialRoute.H"

//#include "GatherCommander.H"
//#include "ClientEventHandler.H"
#include "SimpleGather.H"

#define TEST(x) x

SpecialRoute::SpecialRoute(SimpleGather *commander_,
             const History::Record *mineralRec_,
             TerrainBase::Loc accessPoint_,
             GameObj *cc_,
             sint4 max) 
    : commander(commander_),
      mineralRec(mineralRec_),
      accessPoint(accessPoint_),
      controlCenter(cc_),
      currentWorkers(0),
      maxWorkers(max),
      routeLength(0)
{ 
    setRouteLength(getSimpleRouteLength());
}


SpecialRoute::~SpecialRoute() { }

void SpecialRoute::addWorker(){
    currentWorkers++;
}


TerrainBase::Loc SpecialRoute::getAccessPoint() const{
    return accessPoint;
}

GameObj* SpecialRoute::getCC() const{
    return controlCenter;
}

sint4 SpecialRoute::getCurrentWorkers() const{
    return currentWorkers;
}

sint4 SpecialRoute::getID() const{
    return id;
}

sint4 SpecialRoute::getMaxWorkers() const{
    return maxWorkers;
}

const History::Record* SpecialRoute::getMineralRec() const{ 
    return mineralRec; 
}

real8 SpecialRoute::getRealRouteLength() const{
    /*
    TerrainBase::Loc ccLoc;
    controlCenter->get_center(ccLoc.x, ccLoc.y);
    real8 dist = commander->getDistance(controlCenter, accessPoint, 3);
    TEST(std::cout << "real dist: " << dist << " for " << accessPoint << std::endl);
    */
    return -1;//dist;
}

real8 SpecialRoute::getRouteLength() const{
    return routeLength;
}

real8 SpecialRoute::getSimpleRouteLength() const{
    TerrainBase::Loc ccLoc;
    controlCenter->get_center(ccLoc.x, ccLoc.y);
    return accessPoint.distance(ccLoc);
}

bool SpecialRoute::mineralIsActive() const{
    return mineralRec->isActive();
}

void SpecialRoute::moveToMineral(GameObj *worker) const{
    commander->moveTo(worker, accessPoint);
}

void SpecialRoute::moveToCC(GameObj *worker) const{
    commander->moveTo(worker, controlCenter);
}

void SpecialRoute::removeWorker(){ 
    currentWorkers--; 
}

void SpecialRoute::setID(sint4 id_){ 
    id = id_; 
}

void SpecialRoute:: setRouteLength(real8 length){
    routeLength = length;
}

void SpecialRoute::planSuccessOccurred(){
    planFailures = 0;
}

void SpecialRoute::planFailureOccurred(){
    planFailures++;
}
