/*
 *  SpecialScouting.H
 *  
 *
 *  Created by Sergio on 09/06/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */
 
#ifndef SpecialScouting_H
#define SpecialScouting_H

#include "Game.H"
#include "GameObj.H"
#include "Movement.H"
#include "ModuleSet.H"
#include "EventHandler.H"
#include "Watcher.H"


/* Estructura para realizar el scauting */
struct Scouting{
	
	/* Scaut */
	GameObj * scout;
	
	/* Destino del scaut */
	ScalarPoint target;
	
	/* true si ha llegado al destino */
	bool running;
	
	short contador;
	
	/* Constructor */
	Scouting(GameObj * scout_){
		scout = scout_;
		contador = 0;
		running = false;		
	}
};



/* Clase SpecialScouting */
class SpecialScouting : EventHandler{

public:	
		
	void addScout(GameObj* gob);
	
	GameObj* removeScout();
	
	unsigned getNumberScouts();

	void scouting(const Map<GameTile> &map);
	
	void onLoseUnit(GameObj * unit);
	
	bool handle_event(const Event &event);
	
	SpecialScouting(sint4 seed, ModuleSet & msGeneral, ModuleSet & msGather): mc(msGeneral.get_movement(), "Default", "Default"), moduleSet(msGather){
		rand.srand(seed);
	}

private:

	Vector<Scouting> scouts;		
	
	Random rand;
	
	Movement::Context mc;
	
	ModuleSet & moduleSet;
	
	ScalarPoint getTargetTile(const Map<GameTile> &map);
	
	real8 getDistanceToTarget(ScalarPoint targetScaut, sint4 x, sint4 y);
	
	void removeScout(GameObj* gob);
	
};

#endif
